CollectionDeserializer
Date: 2016-12-04

com.fasterxml.jackson.databind.deser.std

## Class CollectionDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<T>
    - - com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase<java.util.Collection<java.lang.Object>>
      - - com.fasterxml.jackson.databind.deser.std.CollectionDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, java.io.Serializable
  Direct Known Subclasses:
    ArrayBlockingQueueDeserializer

      public class CollectionDeserializer
      extends ContainerDeserializerBase<java.util.Collection<java.lang.Object>>
      implements ContextualDeserializer

  Basic serializer that can take JSON "Array" structure and construct a `Collection` instance, with typed contents.

  Note: for untyped content (one indicated by passing Object.class as the type), `UntypedObjectDeserializer` is used instead. It can also construct `List`s, but not with specific POJO types, only other containers and primitives/wrappers.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `CollectionDeserializer.CollectionReferringAccumulator`

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JavaType` | `_collectionType`
    `protected JsonDeserializer<java.lang.Object>` | `_delegateDeserializer` Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.
    `protected java.lang.Boolean` | `_unwrapSingle` Specific override for this instance (from proper, or global per-type overrides) to indicate whether single value may be taken to mean an unwrapped one-element array or not.
    `protected JsonDeserializer<java.lang.Object>` | `_valueDeserializer` Value deserializer.
    `protected ValueInstantiator` | `_valueInstantiator`
    `protected TypeDeserializer` | `_valueTypeDeserializer` If element instances have polymorphic type information, this is the type deserializer that can handle it

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CollectionDeserializer(CollectionDeserializer src)` Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.
    `` | `CollectionDeserializer(JavaType collectionType, JsonDeserializer<java.lang.Object> valueDeser, TypeDeserializer valueTypeDeser, ValueInstantiator valueInstantiator)` Constructor for context-free instances, where we do not yet know which property is using this deserializer.
    `protected` | `CollectionDeserializer(JavaType collectionType, JsonDeserializer<java.lang.Object> valueDeser, TypeDeserializer valueTypeDeser, ValueInstantiator valueInstantiator, JsonDeserializer<java.lang.Object> delegateDeser, java.lang.Boolean unwrapSingle)` Constructor used when creating contextualized instances.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `CollectionDeserializer` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to finalize setup of this deserializer, when it is known for which property deserializer is needed for.
    `java.util.Collection<java.lang.Object>` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `java.util.Collection<java.lang.Object>` | `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.util.Collection<java.lang.Object> result)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `java.lang.Object` | `deserializeWithType(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `JsonDeserializer<java.lang.Object>` | `getContentDeserializer()` Accesor for deserializer use for deserializing content values.
    `JavaType` | `getContentType()` Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
    `protected java.util.Collection<java.lang.Object>` | `handleNonArray(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.util.Collection<java.lang.Object> result)` Helper method called when current token is no START_ARRAY.
    `boolean` | `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
    `protected CollectionDeserializer` | `withResolved(JsonDeserializer<?> dd, JsonDeserializer<?> vd, TypeDeserializer vtd)` Deprecated. Since 2.7 as it does not pass `unwrapSingle`
    `protected CollectionDeserializer` | `withResolved(JsonDeserializer<?> dd, JsonDeserializer<?> vd, TypeDeserializer vtd, java.lang.Boolean unwrapSingle)` Fluent-factory method call to construct contextual instance.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.ContainerDeserializerBase

      `findBackReference, wrapAndThrow`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_coerceIntegral, _deserializeFromEmpty, _failDoubleToIntCoercion, _hasTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _parseBoolean, _parseBooleanFromInt, _parseBooleanFromOther, _parseBooleanPrimitive, _parseByte, _parseDate, _parseDate, _parseDouble, _parseDoublePrimitive, _parseFloat, _parseFloatPrimitive, _parseInteger, _parseIntPrimitive, _parseLong, _parseLongPrimitive, _parseShort, _parseShortPrimitive, _parseString, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, getValueClass, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `getDelegatee, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _collectionType

          protected final JavaType _collectionType

    - #### _valueDeserializer

          protected final JsonDeserializer<java.lang.Object> _valueDeserializer

      Value deserializer.

    - #### _valueTypeDeserializer

          protected final TypeDeserializer _valueTypeDeserializer

      If element instances have polymorphic type information, this is the type deserializer that can handle it

    - #### _valueInstantiator

          protected final ValueInstantiator _valueInstantiator

    - #### _delegateDeserializer

          protected final JsonDeserializer<java.lang.Object> _delegateDeserializer

      Deserializer that is used iff delegate-based creator is to be used for deserializing from JSON Object.

    - #### _unwrapSingle

          protected final java.lang.Boolean _unwrapSingle

      Specific override for this instance (from proper, or global per-type overrides) to indicate whether single value may be taken to mean an unwrapped one-element array or not. If null, left to global defaults.
      Since:
        2.7

  - ### Constructor Detail

    - #### CollectionDeserializer

          public CollectionDeserializer(JavaType collectionType,
                                JsonDeserializer<java.lang.Object> valueDeser,
                                TypeDeserializer valueTypeDeser,
                                ValueInstantiator valueInstantiator)

      Constructor for context-free instances, where we do not yet know which property is using this deserializer.

    - #### CollectionDeserializer

          protected CollectionDeserializer(JavaType collectionType,
                                JsonDeserializer<java.lang.Object> valueDeser,
                                TypeDeserializer valueTypeDeser,
                                ValueInstantiator valueInstantiator,
                                JsonDeserializer<java.lang.Object> delegateDeser,
                                java.lang.Boolean unwrapSingle)

      Constructor used when creating contextualized instances.

    - #### CollectionDeserializer

          protected CollectionDeserializer(CollectionDeserializer src)

      Copy-constructor that can be used by sub-classes to allow copy-on-write styling copying of settings of an existing instance.

  - ### Method Detail

    - #### withResolved

          protected CollectionDeserializer withResolved(JsonDeserializer<?> dd,
                                            JsonDeserializer<?> vd,
                                            TypeDeserializer vtd,
                                            java.lang.Boolean unwrapSingle)

      Fluent-factory method call to construct contextual instance.
      Since:
        2.7

    - #### withResolved

          @Deprecated
          protected CollectionDeserializer withResolved(JsonDeserializer<?> dd,
                                                       JsonDeserializer<?> vd,
                                                       TypeDeserializer vtd)

      Deprecated. Since 2.7 as it does not pass `unwrapSingle`

    - #### isCachable

          public boolean isCachable()

      Description copied from class: `JsonDeserializer`
      Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

      Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

      Default implementation returns false, to indicate that no caching is done.

      Overrides:
        `isCachable` in class `JsonDeserializer<java.util.Collection<java.lang.Object>>`

    - #### createContextual

          public CollectionDeserializer createContextual(DeserializationContext ctxt,
                                                BeanProperty property)
                                                  throws JsonMappingException

      Method called to finalize setup of this deserializer, when it is known for which property deserializer is needed for.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller can not provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### getContentType

          public JavaType getContentType()

      Description copied from class: `ContainerDeserializerBase`
      Accessor for declared type of contained value elements; either exact type, or one of its supertypes.
      Specified by:
        `getContentType` in class `ContainerDeserializerBase<java.util.Collection<java.lang.Object>>`

    - #### getContentDeserializer

          public JsonDeserializer<java.lang.Object> getContentDeserializer()

      Description copied from class: `ContainerDeserializerBase`
      Accesor for deserializer use for deserializing content values.
      Specified by:
        `getContentDeserializer` in class `ContainerDeserializerBase<java.util.Collection<java.lang.Object>>`

    - #### deserialize

          public java.util.Collection<java.lang.Object> deserialize(com.fasterxml.jackson.core.JsonParser p,
                                                           DeserializationContext ctxt)
                                                             throws java.io.IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (jp.getCurrentToken() == JsonToken.START_OBJECT) {
                   jp.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<java.util.Collection<java.lang.Object>>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `java.io.IOException`

    - #### deserialize

          public java.util.Collection<java.lang.Object> deserialize(com.fasterxml.jackson.core.JsonParser p,
                                                           DeserializationContext ctxt,
                                                           java.util.Collection<java.lang.Object> result)
                                                             throws java.io.IOException

      Description copied from class: `JsonDeserializer`
      Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

      Overrides:
        `deserialize` in class `JsonDeserializer<java.util.Collection<java.lang.Object>>`
      Throws:
        `java.io.IOException`

    - #### deserializeWithType

          public java.lang.Object deserializeWithType(com.fasterxml.jackson.core.JsonParser p,
                                             DeserializationContext ctxt,
                                             TypeDeserializer typeDeserializer)
                                               throws java.io.IOException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<java.util.Collection<java.lang.Object>>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `java.io.IOException`

    - #### handleNonArray

          protected final java.util.Collection<java.lang.Object> handleNonArray(com.fasterxml.jackson.core.JsonParser p,
                                                              DeserializationContext ctxt,
                                                              java.util.Collection<java.lang.Object> result)
                                                                         throws java.io.IOException

      Helper method called when current token is no START_ARRAY. Will either throw an exception, or try to handle value as if member of implicit array, depending on configuration.
      Throws:
        `java.io.IOException`